"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.output = void 0;
const screen_1 = require("../../screen");
const output_1 = require("../guard/output");
function output(result) {
    (0, output_1.output)(result.guardResult);
    (0, screen_1.print)();
    (0, screen_1.printSectionTitle)('Rule Library');
    (0, screen_1.print)();
    for (const category of result.library.categories) {
        (0, screen_1.print)(`${screen_1.OBJECT_ICONS.ruleCategory.get()} ${category.name}`, 2);
        for (const rule of category.rules) {
            (0, screen_1.print)(`${screen_1.OBJECT_ICONS.rule.get()} ${rule.name}`, 5);
            (0, screen_1.print)(`Path: ${rule.path}`, 8);
            (0, screen_1.print)();
        }
    }
    (0, screen_1.print)(`Library Index: ${result.libraryPath}`);
    (0, screen_1.printProcessStatus)(result.success, 'Index Generation');
}
exports.output = output;
//# sourceMappingURL=output.js.map