"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TARGET_QUERY_BUILDER_DICT = exports.TARGET_QUERY_BUILDER_OBJ = exports.TargetQueryBuilderDef = void 0;
const k8s_target_query_1 = require("./k8s/k8s-target-query");
const union_target_query_1 = require("./union/union-target-query");
const transform_target_query_1 = require("./transform/transform-target-query");
const shortcut_target_query_1 = require("./shortcut/shortcut-target-query");
const filter_target_query_1 = require("./filter/filter-target-query");
const transform_many_target_query_1 = require("./transform-many/transform-many-target-query");
class TargetQueryBuilderDef {
    get Shortcut() {
        return (name) => {
            const target = new shortcut_target_query_1.ShortcutTargetQuery();
            return target.Shortcut(name);
        };
    }
    get ApiVersion() {
        return (apiVersion) => {
            const target = new k8s_target_query_1.K8sTargetQuery();
            return target.ApiVersion(apiVersion);
        };
    }
    get Api() {
        return (apiName) => {
            const target = new k8s_target_query_1.K8sTargetQuery();
            return target.Api(apiName);
        };
    }
    get Union() {
        return (...inner) => {
            return new union_target_query_1.UnionTargetQuery(...inner);
        };
    }
    get Transform() {
        return (inner) => {
            return new transform_target_query_1.TransformTargetQuery(inner);
        };
    }
    get TransformMany() {
        return (inner) => {
            return new transform_many_target_query_1.TransformManyTargetQuery(inner);
        };
    }
    get Filter() {
        return (inner) => {
            return new filter_target_query_1.FilterTargetQuery(inner);
        };
    }
}
exports.TargetQueryBuilderDef = TargetQueryBuilderDef;
exports.TARGET_QUERY_BUILDER_OBJ = new TargetQueryBuilderDef();
var TopLevelQuery;
(function (TopLevelQuery) {
    TopLevelQuery["Shortcut"] = "Shortcut";
    TopLevelQuery["ApiVersion"] = "ApiVersion";
    TopLevelQuery["Api"] = "Api";
    TopLevelQuery["Union"] = "Union";
    TopLevelQuery["Transform"] = "Transform";
    TopLevelQuery["TransformMany"] = "TransformMany";
    TopLevelQuery["Filter"] = "Filter";
})(TopLevelQuery || (TopLevelQuery = {}));
exports.TARGET_QUERY_BUILDER_DICT = {
    [TopLevelQuery.Shortcut]: exports.TARGET_QUERY_BUILDER_OBJ.Shortcut,
    [TopLevelQuery.ApiVersion]: exports.TARGET_QUERY_BUILDER_OBJ.ApiVersion,
    [TopLevelQuery.Api]: exports.TARGET_QUERY_BUILDER_OBJ.Api,
    [TopLevelQuery.Union]: exports.TARGET_QUERY_BUILDER_OBJ.Union,
    [TopLevelQuery.Transform]: exports.TARGET_QUERY_BUILDER_OBJ.Transform,
    [TopLevelQuery.TransformMany]: exports.TARGET_QUERY_BUILDER_OBJ.TransformMany,
    [TopLevelQuery.Filter]: exports.TARGET_QUERY_BUILDER_OBJ.Filter,
};
//# sourceMappingURL=scope-builder.js.map