"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = void 0;
const scope_builder_1 = require("../../query-spec/scope-builder");
function setup(executor) {
    const { Shortcut, ApiVersion, Api, Union, Transform, TransformMany, Filter } = scope_builder_1.TARGET_QUERY_BUILDER_OBJ;
    executor.setup('DeploymentPodSpec', () => Transform(ApiVersion('apps/v1')
        .Kind("Deployment")).To(item => {
        var _a, _b, _c, _d, _e, _f;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `Deployment-${(_d = item.config.metadata) === null || _d === void 0 ? void 0 : _d.name}` }),
            spec: (_f = (_e = item.config.spec) === null || _e === void 0 ? void 0 : _e.template) === null || _f === void 0 ? void 0 : _f.spec
        });
    }));
    executor.setup('StatefulSetPodSpec', () => Transform(ApiVersion('apps/v1')
        .Kind("StatefulSet")).To(item => {
        var _a, _b, _c, _d, _e, _f;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `StatefulSet-${(_d = item.config.metadata) === null || _d === void 0 ? void 0 : _d.name}` }),
            spec: (_f = (_e = item.config.spec) === null || _e === void 0 ? void 0 : _e.template) === null || _f === void 0 ? void 0 : _f.spec
        });
    }));
    executor.setup('DaemonSetPodSpec', () => Transform(ApiVersion('apps/v1')
        .Kind("DaemonSet")).To(item => {
        var _a, _b, _c, _d, _e, _f;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `DaemonSet-${(_d = item.config.metadata) === null || _d === void 0 ? void 0 : _d.name}` }),
            spec: (_f = (_e = item.config.spec) === null || _e === void 0 ? void 0 : _e.template) === null || _f === void 0 ? void 0 : _f.spec
        });
    }));
    executor.setup('JobPodSpec', () => Transform(Filter(Api('batch')
        .Kind("Job")).Criteria(item => {
        var _a;
        if ((_a = item.config.metadata) === null || _a === void 0 ? void 0 : _a.ownerReferences) {
            return false;
        }
        return true;
    })).To(item => {
        var _a, _b, _c, _d, _e, _f;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `Job-${(_d = item.config.metadata) === null || _d === void 0 ? void 0 : _d.name}` }),
            spec: (_f = (_e = item.config.spec) === null || _e === void 0 ? void 0 : _e.template) === null || _f === void 0 ? void 0 : _f.spec
        });
    }));
    executor.setup('CronJobPodSpec', () => Transform(Api('batch')
        .Kind("CronJob")).To(item => {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        return ({
            synthetic: true,
            apiVersion: 'v1',
            kind: 'PodSpec',
            metadata: Object.assign(Object.assign({}, (_c = (_b = (_a = item.config.spec) === null || _a === void 0 ? void 0 : _a.template) === null || _b === void 0 ? void 0 : _b.metadata) !== null && _c !== void 0 ? _c : {}), { name: `CronJob-${(_d = item.config.metadata) === null || _d === void 0 ? void 0 : _d.name}` }),
            spec: (_h = (_g = (_f = (_e = item.config.spec) === null || _e === void 0 ? void 0 : _e.jobTemplate) === null || _f === void 0 ? void 0 : _f.spec) === null || _g === void 0 ? void 0 : _g.template) === null || _h === void 0 ? void 0 : _h.spec
        });
    }));
    executor.setup('PodSpec', () => Union(Shortcut('DeploymentPodSpec'), Shortcut('StatefulSetPodSpec'), Shortcut('DaemonSetPodSpec'), Shortcut('JobPodSpec'), Shortcut('CronJobPodSpec')));
    executor.setup('ContainerSpec', () => TransformMany(Shortcut('PodSpec')).To(item => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        const results = [];
        for (const cont of (_b = (_a = item === null || item === void 0 ? void 0 : item.config.spec) === null || _a === void 0 ? void 0 : _a.containers) !== null && _b !== void 0 ? _b : []) {
            results.push({
                synthetic: true,
                apiVersion: 'v1',
                kind: 'ContainerSpec',
                metadata: Object.assign(Object.assign({}, (_e = (_d = (_c = item.config.spec) === null || _c === void 0 ? void 0 : _c.template) === null || _d === void 0 ? void 0 : _d.metadata) !== null && _e !== void 0 ? _e : {}), { name: `${(_f = item.config.metadata) === null || _f === void 0 ? void 0 : _f.name}-Cont-${cont.name}` }),
                spec: cont
            });
        }
        for (const cont of (_h = (_g = item === null || item === void 0 ? void 0 : item.config.spec) === null || _g === void 0 ? void 0 : _g.initContainers) !== null && _h !== void 0 ? _h : []) {
            results.push({
                synthetic: true,
                apiVersion: 'v1',
                kind: 'ContainerSpec',
                metadata: Object.assign(Object.assign({}, (_l = (_k = (_j = item.config.spec) === null || _j === void 0 ? void 0 : _j.template) === null || _k === void 0 ? void 0 : _k.metadata) !== null && _l !== void 0 ? _l : {}), { name: `${(_m = item.config.metadata) === null || _m === void 0 ? void 0 : _m.name}-InitCont-${cont.name}` }),
                spec: cont
            });
        }
        return results;
    }));
}
exports.setup = setup;
//# sourceMappingURL=library.js.map